%define anolis_release 2

%undefine __cmake_in_source_build
%bcond_without static_libs

Summary:        Library providing binary-decimal and decimal-binary routines for IEEE doubles
Name:           double-conversion
Version:        3.1.5
Release:        %{anolis_release}%{dist}

License:        BSD
Source0:        https://github.com/google/double-conversion/archive/v%{version}/%{name}-%{version}.tar.gz
URL:            https://github.com/google/double-conversion
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  cmake
Patch001:	0001-Add-loongarch-support-for-double-conversion.patch

%description
Provides binary-decimal and decimal-binary routines for IEEE doubles.
The library consists of efficient conversion routines that have been
extracted from the V8 JavaScript engine. The code has been re-factored
and improved so that it can be used more easily in other projects.

%package devel
Summary:    Library providing binary-decimal and decimal-binary routines for IEEE doubles
Requires:   %{name} = %{version}-%{release}

%description devel
Contains header files for developing applications that use the %{name}
library.

There is extensive documentation in src/double-conversion.h. Other
examples can be found in test/cctest/test-conversions.cc.

%package static
Summary:    Library providing binary-decimal and decimal-binary routines for IEEE doubles
Requires:   %{name}-devel = %{version}-%{release}

%description static
Static %{name} library.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1

%build
%global _vpath_builddir build-shared
%cmake -DBUILD_TESTING=ON
%cmake_build

%if %{with static_libs}
%global _vpath_builddir build-static
CXXFLAGS="%{optflags} -fPIC" %cmake -DBUILD_SHARED_LIBS=NO
%cmake_build
%endif

%install
%if %{with static_libs}
%global _vpath_builddir build-static
%cmake_install
%endif

%global _vpath_builddir build-shared
%cmake_install

%check
%ctest

%generate_compatibility_deps

%files
%license LICENSE
%dir %{abidir}
%{_libdir}/libdouble-conversion.so.3*
%{abidir}/libdouble-conversion.dump

%files devel
%{_libdir}/libdouble-conversion.so
%{_libdir}/cmake/%{name}
%{_includedir}/%{name}

%if %{with static_libs}
%files static
%{_libdir}/libdouble-conversion.a
%endif

%files doc
%doc README.md AUTHORS Changelog

%changelog
* Thu Sep 28 2023 Wenlong Zhang <zhangwenlong@loongson.cn> - 3.1.5-2
- Add loongarch support for double-conversion

* Fri Mar 24 2023 yuanhui <yuanhui@linux.alibaba.com> - 3.1.5-1
- Init package from upstream
